Bug 639615 - Review Request: rubygem-rvm - Ruby Version Manager
Summary: Review Request: rubygem-rvm - Ruby Version Manager
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Ryan Rix
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-10-02 15:39 UTC by Michal Fojtik
Modified: 2010-11-23 21:56 UTC (History)
5 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2010-11-23 21:52:55 UTC
ry: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Michal Fojtik 2010-10-02 15:39:28 UTC
Spec URL: http://mifo.sk/RPMS/rubygem-rvm.spec
SRPM URL: http://mifo.sk/RPMS/rubygem-rvm-1.0.11-2.fc13.src.rpm
Description:

RVM is a command line tool which allows us to easily install, manage and work with multiple ruby environments from interpreters to sets of gems.

Comment 1 Michal Fojtik 2010-10-02 15:40:38 UTC
Additional informations:

Koji build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2508166

rpmlint output:
$ rpmlint rubygem-rvm-1.0.11-2.fc13.noarch.rpm
rubygem-rvm.noarch: W: no-documentation
rubygem-rvm.noarch: W: no-manual-page-for-binary rvm-install
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

 - Documentation is moved to a separate package

Comment 2 Ryan Rix 2010-10-13 00:43:38 UTC
I'll take this review.

Comment 3 Ryan Rix 2010-10-13 01:08:02 UTC
General Musts:
+ MUST: rpmlint must be run on every package. The output should be posted in the review.
+ MUST: The package must be named according to the Package Naming Guidelines .
+MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] . 
MUST: The package must meet the Packaging Guidelines .
+MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
+MUST: The License field in the package spec file must match the actual license. [3]
?MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
+MUST: The spec file must be written in American English. [5]
+MUST: The spec file for the package MUST be legible. [6]
!MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. 
+MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
-MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
+MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
+MUST: Packages must NOT bundle copies of system libraries.[11]
MUST: If the package is designed to be relocatable, the packager must state this fact in +the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]
+MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
+MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]
+MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]
+MUST: Each package must consistently use macros. [16]
+MUST: The package must contain code, or permissable content. [17]
+MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
+MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
+MUST: All filenames in rpm packages must be valid UTF-8. [24]

Ruby specific Packaging guidelines:
+- Requires: ruby(api) = 1.8
+- BuildRequires: ruby
+- Packages that contain Ruby Gems must be called rubygem-%{gemname} where gemname is the name from the Gem's specification.
+- The Source of the package must be the full URL to the released Gem archive; the version of the package must be the Gem's version
+-The package must have a Requires and a BuildRequires on rubygems
+-The package must provide rubygem(%{gemname}) where gemname is the name from the Gem's specification. For every dependency on a Gem named gemdep, the package must contain a Requires on rubygem(%{gemdep}) with the same version constraints as the Gem
+-The %prep and %build sections of the specfile should be empty.
+-The Gem must be installed into %{gemdir} defined as
%global gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
+-The install should be performed with the command
gem install --local --install-dir %{buildroot}%{gemdir} --force %{SOURCE0}
+-Architecture-specific content must not be installed into %{gemdir}
+-If the Gem only contains pure Ruby code, it must be marked as BuildArch: noarch. If the Gem contains binary content (e.g., for a database driver), it must be marked as architecture specific, and all architecture specific content must be moved from the %{gemdir} to the [#ruby_sitearch %{ruby_sitearch} directory] during %install



....


So, after all of that, here's what I'm left with:
!MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
Please fix the URL, it's missing a / :) Source does match though.

A few personal annoyances: I'm not sure that having LICENSE only in -docs is acceptable under guidelines. Please move it from %files docs to a %docs section in each package which rubygem-rvm.spec creates.


Other than those two issues, this package is more or less a good example of how to package ruby gems :)

Once those two issues are taken care of, we're good to go!

Comment 4 Ryan Rix 2010-10-28 03:59:23 UTC
Any word on this, Michal?

Comment 5 Michal Fojtik 2010-10-29 08:46:05 UTC
(In reply to comment #4)
> Any word on this, Michal?

Hi, sorry for the delay, but I was terribly busy last days. I fixed all things you mentioned above also moved README to main package and source.
However, there is also one issue with installing this package and running rvm-install command, which will need some more patching/work:

/usr/bin/rvm-install:19:in `load': /usr/lib/ruby/gems/1.8/gems/rvm-1.0.11/bin/rvm-install:3: syntax error, unexpected tIDENTIFIER, expecting kDO or '{' or '(' (SyntaxError)
/usr/lib/ruby/gems/1.8/gems/rvm-1.0.11/bin/rvm-install:6: syntax error, unexpected tSTRING_BEG, expecting kDO or '{' or '('
if [[ -z "$rvm_selfcontained" ]]; then
          ^
/usr/lib/ruby/gems/1.8/gems/rvm-1.0.11/bin/rvm-install:6: syntax error, unexpected ']', expecting $end
if [[ -z "$rvm_selfcontained" ]]; then
                               ^
        from /usr/bin/rvm-install:19

Btw. Thank you for review. I'll push fixed version very soon.


* Fri Oct 29 2010 Michal Fojtik <mfojtik@redhat.com> - 1.0.11-3
- LICENSE and README moved to main package

Spec URL: http://mifo.sk/RPMS/rubygem-rvm.spec
SRPM URL: http://mifo.sk/RPMS/rubygem-rvm-1.0.11-3.fc13.src.rpm

Comment 6 Michal Fojtik 2010-10-29 09:26:35 UTC
OK this issue is gone from >1.0.15.

* Fri Oct 29 2010 Michal Fojtik <mfojtik@redhat.com> - 1.0.15-1
- Version bump
- Fixed rvm-install script

=============== 1.0.15-1 ================

Spec URL: http://mifo.sk/RPMS/rubygem-rvm.spec
SRPM URL: http://mifo.sk/RPMS/rubygem-rvm-1.0.15-1.fc13.src.rpm

Comment 7 Ryan Rix 2010-11-01 07:00:45 UTC
Looks good to me.

APPROVED.

Comment 8 Michal Fojtik 2010-11-01 10:12:25 UTC
Thanks for the review!

New Package SCM Request
=======================
Package Name:      rubygem-rvm
Short Description: Ruby Version Manager
Owners:            mfojtik
Branches:          f12 f13 f14

Comment 9 Kevin Fenzi 2010-11-03 04:05:24 UTC
Git done (by process-git-requests).

With the release of f14, we no longer allow/offer f12 branches.

Comment 10 Fedora Update System 2010-11-03 09:57:20 UTC
rubygem-rvm-1.0.19-1.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/rubygem-rvm-1.0.19-1.fc13

Comment 11 Fedora Update System 2010-11-03 10:02:24 UTC
rubygem-rvm-1.0.19-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/rubygem-rvm-1.0.19-1.fc14

Comment 12 Fedora Update System 2010-11-03 21:08:43 UTC
rubygem-rvm-1.0.19-1.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update rubygem-rvm'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/rubygem-rvm-1.0.19-1.fc14

Comment 13 Fedora Update System 2010-11-23 21:52:50 UTC
rubygem-rvm-1.0.19-1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2010-11-23 21:56:02 UTC
rubygem-rvm-1.0.19-1.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.